LeetCode :6. ZigZag Conversion

LeetCode : ZigZag Conversion

题目:
LeetCode:6. ZigZag Conversion

描述:

The string "PAYPALISHIRING" is written in a zigzag pattern on a given number of rows like this: (you may want to display this pattern in a fixed font for better legibility)

举例:

P   A   H   N
A P L S I I G
Y   I   R  
And then read line by line: "PAHNAPLSIIGYIR"
Write the code that will take a string and make this conversion given a number of rows:
string convert(string text, int nRows);
convert("PAYPALISHIRING", 3) should return "PAHNAPLSIIGYIR".  

分析:

题目的意思是把字符串上下上下走之字形状,然后按行输出.

0   4    8
1 3 5  7 9
2   6    10

输出0->4->8->1->3->5...->6->10

  1. 根据其数组的读写规律,从首行到末行进行依次写入操作
  2. 从首行到末行,根据其递增的特性,从左到右写入

    • 规律如下:
      1.1 首行与末行 每一列递增规律为nInterval(nColumn ) + (i - 1)
      1.2 中间行规律为nInterval
      ((nColumn + 1) / 2) + (i - 1) * (nColumn % 2 ? -1 : 1) 0 + 1 = 1
      2.1 首行每个元素间隔为 nInterval,中间行 间隔为 nInterval - 2 * i 与 2 * i交替,尾行 间隔为 nInterval.
      备注:其中nInterval是按照规律读写同一位置的间隔。nInterval = (numRows << 1) - 2, i 为行数,ncolumn当前列数,numRows为指定每列数量。

代码:

{
string convertEx(string s, int numRows) {
    int nLen = s.size();
    if (1 == nLen || 1 == numRows)
    {
        return s;
    }
    string strRes(nLen, ' ');
    int nRow = 0;
    int nColumn = 0;
    int nRule = 0;
    int nInterval = (numRows << 1) - 2; // 移位代替 * 2
    int nIndex = 0;
    /*
    首行:     nRule = interval*(nColumn) + nRow
    中间行:   nRule = interval * ((nColumn + 1) / 2) + nRow * (nColumn % 2 ? -1 : 1)  0 + 1 = 1
    尾行:     nRule = interval*(nColumn) + nRow
    */
    while (nRow < numRows)
    {
        if (0 == nRow)
        {
            nColumn = 0;
            nRule = nInterval * nColumn;
            while (nRule < nLen)
            {
                strRes[nIndex] = s[nRule];
                ++nColumn;
                ++nIndex;
                nRule = nInterval * nColumn;
            }
        }
        else if (nRow < numRows - 1)
        {
            nColumn = 0;
            nRule = nInterval * ((nColumn + 1) >> 1) + nRow * (nColumn % 2 ? -1 : 1);
            while (nRule < nLen)
            {
                strRes[nIndex] = s[nRule];
                ++nColumn;
                ++nIndex;
                nRule = nInterval * ((nColumn + 1) >> 1) + nRow * (nColumn % 2 ? -1 : 1);
            }
        }
        else
        {
            nColumn = 0;
            nRule = nInterval * nColumn + nRow;
            while (nRule < nLen)
            {
                strRes[nIndex] = s[nRule];
                ++nColumn;
                ++nIndex;
                nRule = nInterval * nColumn + nRow;
            }
        }
        ++nRow;
    }
    return strRes;
}

}
string convert(string s, int numRows) {
    int nLen = s.size();
    if (1 == nLen || 1 == numRows)
    {
        return s;
    }
    string strRes(nLen, ' ');
    int nInterval = (numRows << 1) - 2; // 移位代替 * 2
    int nIndex = 0;
    // 首行 间隔为 nInterval
    for (int i = 0; i < nLen; i += nInterval)
    {
        strRes[nIndex++] = s[i];
    }
    // 中间行 间隔为  nInterval - 2 * i 与 2 * i交替
    for (int i = 1; i < numRows - 1; i++)
    {
        int nInterTemp = i << 1;
        for (int j = i; j < nLen; j += nInterTemp)
        {
            strRes[nIndex++] = s[j];
            nInterTemp = nInterval - nInterTemp; // 和为nInterval 互补
        }
    }
    // 尾行 间隔为 nInterval
    for (int i = numRows - 1; i < nLen; i += nInterval)
    {
        strRes[nIndex++] = s[i];
    }
    return strRes;
}

转载于:https://www.cnblogs.com/liuwfuang96/p/6854440.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值